
Public Class Form1
    Dim wRtn As Short

    Dim wTotalBoards As Short
    Dim wBoardNo As Short
    Dim bSelCardID As Byte

    Dim mpbo() As PictureBox    'Output PictureBox Control's Array
    Dim mpbof(31) As Boolean
    Dim mpbi() As PictureBox    'Input PictureBox Control's Array

    Dim mrbSetDio() As RadioButton

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim index As UInt16
        Dim bCardID As Byte
        Dim bAvailCard(15) As Byte

        '//Search Card
        wRtn = d64h_scan(wTotalBoards, bAvailCard(0))
        If (wRtn <> SUCCESS_NO_ERROR) Then
            MsgBox("Driver Initial Error!!Error Code:" + Str(wRtn))
            End
        End If

        For index = 0 To CUShort(wTotalBoards - 1)
            '//Get Card Information
            wRtn = d64h_cardinfo_get(index, bCardID)
            If (wRtn <> SUCCESS_NO_ERROR) Then
                MsgBox("Get Card Information Err")
            End If

            Me.cbxSelectBoard.Items.Add(Str(index) + ": &H" + Str(bCardID))

        Next

        mpbo = CType(ControlArrayUtils.getControlArray(Me.gbxOutput, "pbOut"), PictureBox())
        mpbi = CType(ControlArrayUtils.getControlArray(Me.gbxInput, "pbIn"), PictureBox())
        'mrbSetDio = CType(ControlArrayUtils.getControlArray(Me.gbDIOSetting, "rbDIOM"), RadioButton())

        Dim i As Short
        For i = 1 To 32
            mpbo(i).Image = My.Resources.gray
            mpbi(i).Image = My.Resources.gray

            mpbo(i).Enabled = False
            mpbof(i - 1) = False
            mpbi(i).Enabled = False
            mpbo(i).SizeMode = PictureBoxSizeMode.StretchImage
            mpbi(i).SizeMode = PictureBoxSizeMode.StretchImage
            AddHandler mpbo(i).Click, AddressOf SignalOutput
        Next


    End Sub

    '//For picturebox control array Handle, and Digital Output control
    Private Sub SignalOutput(ByVal sender As System.Object, ByVal e As System.EventArgs)

        Dim i As Short
        Dim DoVal As UInt32
        Dim index As UInt16

        i = CShort(DirectCast(sender, PictureBox).Name.Remove(0, 5))

        mpbof(i - 1) = Not mpbof(i - 1)


        If mpbof(i - 1) = False Then
            mpbo(i).Image = My.Resources.gray
        Else
            mpbo(i).Image = My.Resources.red
        End If

        'Dim DoVal1 As ULong
        DoVal = 0
        For index = 0 To 31
            If mpbof(index) Then
                DoVal = DoVal Or Math.Pow(2, index)
                'DoVal1 = &HFFFFFFFF
            End If
        Next

        tbxOutput.Text = Hex(DoVal)
        '//Write DO Port
        wRtn = d64h_do_writeport(bSelCardID, DoVal)
        'PIODA_DO(CShort(nudActive.Value), DoVal)    ' PCI-P16R16
        'tbxOutput.Text = Hex(DoVal)

    End Sub

    Private Sub cbxSelectBoard_SelectedIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles cbxSelectBoard.SelectedIndexChanged

        wBoardNo = CUShort(cbxSelectBoard.SelectedIndex)
        '//Get Card Info
        wRtn = d64h_cardinfo_get(wBoardNo, bSelCardID)

        If (wRtn <> SUCCESS_NO_ERROR) Then
            MsgBox("Get Card Information Err")
        End If

    End Sub

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnExit.Click

        Me.Close()
    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnActive.Click
        Dim index As UInt16

        If (cbxSelectBoard.SelectedIndex = -1) Then
            MsgBox("Please Selected a Board!!!")
            Exit Sub
        End If

        If btnActive.Text = "&Stop" Then
            Timer1.Enabled = False

            btnExit.Enabled = True
            btnActive.Text = "&Active"
            '//Close Card
            wRtn = d64h_close(bSelCardID)
            If (wRtn <> SUCCESS_NO_ERROR) Then
                MsgBox("Close Card Err.Error Code:" + Str(wRtn))
            End If

            For index = 1 To 32
                mpbo(index).Enabled = False
                mpbi(index).Enabled = False
            Next
            Exit Sub
        Else
            btnActive.Text = "&Stop"
            '//Open Card
            wRtn = d64h_open(bSelCardID)
            If (wRtn <> SUCCESS_NO_ERROR) Then
                MsgBox("Open Card Err.Error Code:" + Str(wRtn))
            End If
            For index = 1 To 32
                mpbo(index).Enabled = True
                mpbi(index).Enabled = True
            Next
            Timer1.Enabled = True
            btnExit.Enabled = False
        End If
    End Sub

    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        Dim DIVal As UInt32
        Dim index As UInt16

        '//Read DI Port
        wRtn = d64h_di_readport(bSelCardID, DIVal)
        If (wRtn <> SUCCESS_NO_ERROR) Then
            MsgBox("Read DI port Error!!!")
        End If

        tbxInput.Text = Hex(DIVal)
        For index = 1 To 32
            'If CBool(DIVal And (1 << (index - 1))) Then
            If CBool(DIVal And (Math.Pow(2, (index - 1)))) Then
                mpbi(CInt(index)).Image = My.Resources.red
            Else
                mpbi(CInt(index)).Image = My.Resources.gray
            End If
        Next
        Application.DoEvents()

    End Sub
End Class
